#include "File.h"
#include "Configuration.h"
#include "GameControlBase.h"
#include "PlayerConfiguration.h"

#include "SinglePlayerGame.h"


//----------------------------------------------------------------------------
SinglePlayerGame *SinglePlayerGame::sm_instance = NULL;


//----------------------------------------------------------------------------
SinglePlayerGame::SinglePlayerGame(const char *mission)
        : m_mission(mission)
{
    m_levelReader.init(mission);
    m_levelIter = m_levelReader.begin();
}

//----------------------------------------------------------------------------
SinglePlayerGame::~SinglePlayerGame()
{
}


//----------------------------------------------------------------------------
void SinglePlayerGame::init(const char *mission)
    throw (Exception)
{
    sm_instance = new SinglePlayerGame(mission);
}

//----------------------------------------------------------------------------
void SinglePlayerGame::destroy()
{
    ZAP_POINTER(sm_instance);
}


//----------------------------------------------------------------------------
const std::string &SinglePlayerGame::nextLevel()
{
    const std::string &level = *m_levelIter++;
    PlayerConfiguration::getInstance()->getMission()->updateLastPlayed(
        m_levelReader.getMission(),
        std::distance(m_levelReader.begin(), m_levelIter));

    return level;
}
